! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
! cf. $SAS_DIR/packages/dal/tests/f90test/setcolumn.f90

program mkdata_bkgoptrate

  use dal
  
  implicit none

  integer, parameter :: DEFAULTDIMENSION = 7

  type(DataSetT) :: setRate, setCnt, setFrac
  type(TableT) :: tab
  type(ColumnT) :: colX, colRate, colCnt, colFrac
  real(kind=single), dimension(:), pointer :: cX, cRate, cCnt, cFrac
  ! real(kind=single), dimension(DEFAULTDIMENSION) :: rate, cnt
  integer,           dimension(DEFAULTDIMENSION) :: tSeriesInt, timeInt
  integer(int32),    dimension(:), pointer :: ciCnt
  ! integer(int32),    dimension(DEFAULTDIMENSION) :: iCnt
  ! character(len=1024) :: s

  timeInt(:) =     (/ -2, 0, 1, 2, 3, 4, 5 /)
  tSeriesInt(:) = (/ 1, 2, 4, 4, 5, 8, 9 /)
  ! rate(:) = tSeriesInt
  ! cnt(:)  = tSeriesInt
  ! iCnt(:) = tSeriesInt

  setRate = dataSet("testdata/test_rate.fits",CREATE)
  tab = addTable(setRate,"TIME-SERIES",DEFAULTDIMENSION)
  colX = addColumn(tab,"TIME",REAL32,units="s",comment="real32 column")
  cX => real32Data(colX)
  cX(:) = timeInt

  colRate = addColumn(tab,"RATE",REAL32,units="cnt/s",comment="real32 column")
  cRate => real32Data(colRate)
  cRate(:) = tSeriesInt
  call release(setRate)


  setCnt = dataSet("testdata/test_cnt.fits",CREATE)
  tab = addTable(setCnt,"TIME-SERIES",DEFAULTDIMENSION)
  colX = addColumn(tab,"TIME",REAL32,units="s",comment="real32 column")
  cX => real32Data(colX)
  cX(:) = timeInt

  colCnt = addColumn(tab,"COUNTS",REAL32,units="cnt",comment="Count in real32")
  cCnt => real32Data(colCnt)
  cCnt(:) = tSeriesInt
  call release(setCnt)


  setFrac = dataSet("testdata/test_rfrac.fits",CREATE)
  tab = addTable(setFrac,"TIME-SERIES",DEFAULTDIMENSION)
  colX = addColumn(tab,"TIME",REAL32,units="s",comment="real32 column")
  cX => real32Data(colX)
  cX(:) = timeInt

  colRate = addColumn(tab,"RATE",REAL32,units="cnt/s",comment="real32 column")
  cRate => real32Data(colRate)
  cRate(:) = tSeriesInt

  colFrac = addColumn(tab,"FRACEXP",REAL32,units="",comment="real32 column")
  cFrac => real32Data(colFrac)
  cFrac(:) = 1.0
  cFrac(5) = 0.5
  cFrac(6) = 0.5
  call release(setFrac)

  setFrac = dataSet("testdata/test_cfrac.fits",CREATE)
  tab = addTable(setFrac,"TIME-SERIES",DEFAULTDIMENSION)
  colX = addColumn(tab,"TIME",REAL32,units="s",comment="real32 column")
  cX => real32Data(colX)
  cX(:) = timeInt

  colCnt = addColumn(tab,"COUNTS",INTEGER32,units="cnt",comment="Count in integer32")
  ciCnt => int32Data(colCnt)
  ciCnt(:) = tSeriesInt

  colFrac = addColumn(tab,"FRACEXP",REAL32,units="",comment="real32 column")
  cFrac => real32Data(colFrac)
  cFrac(:) = 1.0
  cFrac(5) = 0.5
  cFrac(6) = 0.5
  call release(setFrac)

end program mkdata_bkgoptrate
